'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getField;
function getWidgetName(schema, map) {
  var type = schema.type,
      format = schema.format,
      enums = schema.enum,
      readonly = schema.readonly;

  var list = [];
  if (readonly) {
    list.push(type + '?readonly');
    list.push('*?readonly');
  }
  if (enums) {
    list.push(type + '?enum');
    // array 默认使用list，array?enum 默认使用checkboxes，*?enum 默认使用select
    list.push('*?enum');
  }
  if (format) {
    list.push(type + ':' + format);
  }
  list.push(type); // 放在最后兜底，其他都不match时使用type默认的组件
  var found = '';
  list.some(function (item) {
    found = map[item];
    return !!found;
  });
  return found;
}

function getField() {
  var schema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _ref = arguments[1];
  var customized = _ref.customized,
      generated = _ref.generated,
      mapping = _ref.mapping;
  var widget = schema['ui:widget'],
      field = schema['ui:field'];
  // Field能否被重定义

  var fieldCanRedefine = false;
  var Field = void 0;
  // ui:widget 是字符串，从generated中查，不是的话，就是本事
  var _widget = typeof widget === 'string' ? generated[widget] : widget;
  if (field && !Field) {
    Field = typeof field === 'string' ? customized[field] : field;
  }
  if (!Field && _widget) {
    Field = _widget;
  }
  if (!Field && !_widget) {
    Field = generated[getWidgetName(schema, mapping)];
    fieldCanRedefine = !!Field;
  }
  return {
    fieldCanRedefine: fieldCanRedefine,
    Field: Field || null
  };
}