'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /**
                                                                                                                                                                                                                                                                               * Created by Tw93 on 2019-04-28.
                                                                                                                                                                                                                                                                               * 表达式判断
                                                                                                                                                                                                                                                                               */

exports.isDependShow = isDependShow;
exports.isHidden = isHidden;

var _pope = require('pope');

var _utils = require('./utils');

function isDependShow() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      formData = _ref.formData,
      dependShow = _ref.dependShow;

  if (formData && dependShow) {
    try {
      return !(0, _utils.parseString)((0, _pope.pope)(dependShow, formData)); //eslint-disable-line
    } catch (e) {
      console.error(e);
    }
  }
}

function isHidden() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      hidden = _ref2.hidden,
      rootValue = _ref2.rootValue,
      formData = _ref2.formData;

  // hidden 为表达式：
  if (typeof hidden === 'string') {
    // 支持 && 和 ||
    var hasAnd = function hasAnd(string) {
      return string.indexOf('&&') > -1;
    };
    var hasOr = function hasOr(string) {
      return string.indexOf('||') > -1;
    };
    var hiddenList = [];
    if (!hasOr(hidden)) {
      if (!hasAnd(hidden)) {
        return calcHidden(hidden, rootValue, formData);
      } else {
        hiddenList = hidden.split('&&').map(function (item) {
          return item.trim();
        });
        return hiddenList.every(function (item) {
          return calcHidden(item, rootValue, formData);
        });
      }
    } else {
      hiddenList = hidden.split('||').map(function (item) {
        return item.trim();
      });
      if (!hasAnd(hidden)) {
        return hiddenList.some(function (item) {
          return calcHidden(item, rootValue, formData);
        });
      } else {
        return hiddenList.some(function (item) {
          if (hasAnd(item)) {
            var list = item.split('&&').map(function (item) {
              return item.trim();
            });
            return list.every(function (x) {
              return calcHidden(x, rootValue, formData);
            });
          } else {
            return calcHidden(item, rootValue, formData);
          }
        });
      }
    }
  }
  return hidden;
}

// data = {a: b: {c: 1}}  getExpressionValue(data, 'a.b.c')
var getExpressionValue = function getExpressionValue(formData, expression) {
  if (typeof expression !== 'string') return '';
  var keyList = expression.split('.') || [];
  if (keyList.length === 0) {
    return '';
  }
  if (keyList.length === 1) {
    return formData[keyList[0]];
  }
  return keyList.reduce(function (x, y) {
    if (x && (typeof x === 'undefined' ? 'undefined' : _typeof(x)) === 'object') return x[y];
    return '';
  }, formData);
};

// 计算单个表达式的hidden值
var calcHidden = function calcHidden(hiddenString, rootValue, formData) {
  if (!rootValue || (typeof rootValue === 'undefined' ? 'undefined' : _typeof(rootValue)) !== 'object') {
    return false;
  }
  // 支持四种基本运算符
  var operators = ['==', '!=', '>', '<'];
  try {
    var op = operators.find(function (op) {
      return hiddenString.indexOf(op) > -1;
    });

    var _hiddenString$split$m = hiddenString.split(op).map(function (item) {
      return item.trim();
    }),
        _hiddenString$split$m2 = _slicedToArray(_hiddenString$split$m, 2),
        key = _hiddenString$split$m2[0],
        value = _hiddenString$split$m2[1];

    var left = rootValue[key];
    // feature: 允许从 formData 取值
    if (key.substring(0, 9) === 'formData.' && formData) {
      var subKey = key.substring(9);
      left = getExpressionValue(formData, subKey);
    }
    var right = (0, _utils.parseString)(value);
    return (0, _utils.parseString)('"' + String(left) + '"' + op + '"' + String(right) + '"');
  } catch (e) {
    console.error(e);
  }
  return false;
};