'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = listHoc;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactSortableHoc = require('react-sortable-hoc');

var _utils = require('../base/utils');

var _foldIcon = require('./foldIcon');

var _foldIcon2 = _interopRequireDefault(_foldIcon);

var _descList = require('./descList');

var _descList2 = _interopRequireDefault(_descList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by Tw93 on 2019-12-01.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 抽离高阶列表组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var DragHandle = (0, _reactSortableHoc.SortableHandle)(function () {
  return _react2.default.createElement(
    'span',
    { className: 'fr-move-icon' },
    ':::'
  );
});

var listItemHoc = function listItemHoc(ButtonComponent) {
  return function (_React$Component) {
    _inherits(_class2, _React$Component);

    function _class2() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, _class2);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class2.__proto__ || Object.getPrototypeOf(_class2)).call.apply(_ref, [this].concat(args))), _this), _this.toggleFold = function () {
        _this.props.toggleFoldItem(_this.props.name);
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(_class2, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _props = this.props,
            _props$p = _props.p,
            p = _props$p === undefined ? {} : _props$p,
            name = _props.name,
            fold = _props.fold;

        var description = (0, _descList.getDescription)({
          schema: p.schema,
          value: p.value,
          index: name
        });
        // 如果第一个值不为空，则收起
        // 新增的值为0，不折叠
        var hasValue = description && description[0] && description[0].text;
        if (hasValue && fold !== 0) {
          this.props.toggleFoldItem(name);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _props2 = this.props,
            item = _props2.item,
            _props2$p = _props2.p,
            p = _props2$p === undefined ? {} : _props2$p,
            name = _props2.name,
            fold = _props2.fold;

        var descProps = _extends({}, p, { index: name });
        var _p$options = p.options,
            options = _p$options === undefined ? {} : _p$options,
            readonly = p.readonly,
            formData = p.formData,
            rootValue = p.value;
        var canFold = options.foldable,
            hideIndex = options.hideIndex;
        var hideDelete = options.hideDelete,
            itemButtons = options.itemButtons;

        // 判断 hideDelete 是不是函数，是的话将计算后的值赋回

        var _isFunction = (0, _utils.isFunction)(hideDelete);
        if (_isFunction) {
          // isFunction 返回为 true 则说明只可能为 string | Function
          if (typeof _isFunction === 'string') {
            hideDelete = (0, _utils.evaluateString)(_isFunction, formData, rootValue);
          } else if (typeof _isFunction === 'function') {
            hideDelete = _isFunction(formData, rootValue);
          }
        }

        // 只有当items为object时才做收起（fold）处理
        var isObj = p.schema.items && p.schema.items.type == 'object';
        var setClass = 'fr-set ba b--black-10 hover-b--black-20 relative flex flex-column';
        if (canFold && fold) {
          setClass += ' pv12';
        } else if (p.displayType === 'row') {
          setClass += ' pt44';
        }
        return _react2.default.createElement(
          'li',
          { className: setClass },
          hideIndex ? null : _react2.default.createElement(
            'div',
            {
              className: 'absolute top-0 left-0 bg-blue',
              style: {
                paddingLeft: 4,
                paddingRight: 6,
                borderBottomRightRadius: 8,
                borderTopLeftRadius: 3,
                backgroundColor: 'rgba(0, 0, 0, .36)',
                fontSize: 8,
                color: '#fff'
              }
            },
            name + 1
          ),
          canFold && fold && isObj ? _react2.default.createElement(_descList2.default, descProps) : item,
          canFold && _react2.default.createElement(_foldIcon2.default, {
            fold: fold,
            onClick: this.toggleFold,
            style: { position: 'absolute', top: 12, right: 32 }
          }),
          !readonly && _react2.default.createElement(DragHandle, null),
          !(canFold && fold || hideDelete || readonly) && _react2.default.createElement(
            'div',
            { className: 'self-end flex' },
            _react2.default.createElement(
              ButtonComponent,
              {
                type: 'dashed',
                icon: 'delete',
                onClick: function onClick() {
                  var value = [].concat(_toConsumableArray(p.value));
                  value.splice(name, 1);
                  p.onChange(p.name, value);
                }
              },
              '\u5220\u9664'
            ),
            itemButtons && itemButtons.length > 0 && itemButtons.map(function (btn, idx) {
              return _react2.default.createElement(
                ButtonComponent,
                {
                  key: idx.toString(),
                  className: 'ml2',
                  type: 'dashed',
                  icon: btn.icon,
                  onClick: function onClick() {
                    var value = [].concat(_toConsumableArray(p.value));
                    if (typeof window[btn.callback] === 'function') {
                      var result = window[btn.callback](value, name); // eslint-disable-line
                      p.onChange(p.name, result);
                    }
                  }
                },
                btn.text || ''
              );
            })
          )
        );
      }
    }]);

    return _class2;
  }(_react2.default.Component);
};

var fieldListHoc = function fieldListHoc(ButtonComponent) {
  var SortableItem = (0, _reactSortableHoc.SortableElement)(listItemHoc(ButtonComponent));
  return function (_React$Component2) {
    _inherits(_class4, _React$Component2);

    function _class4() {
      var _ref2;

      var _temp2, _this2, _ret2;

      _classCallCheck(this, _class4);

      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref2 = _class4.__proto__ || Object.getPrototypeOf(_class4)).call.apply(_ref2, [this].concat(args))), _this2), _this2.handleAddClick = function () {
        var _this2$props = _this2.props,
            p = _this2$props.p,
            addUnfoldItem = _this2$props.addUnfoldItem;

        var value = [].concat(_toConsumableArray(p.value));
        value.push(p.newItem);
        p.onChange(p.name, value);
        addUnfoldItem();
      }, _temp2), _possibleConstructorReturn(_this2, _ret2);
    }

    _createClass(_class4, [{
      key: 'render',

      // buttons is a list, each item looks like:
      // {
      //   "text": "删除全部",
      //   "icon": "delete",
      //   "callback": "clearAll"
      // }

      value: function render() {
        var _props3 = this.props,
            p = _props3.p,
            _props3$foldList = _props3.foldList,
            foldList = _props3$foldList === undefined ? [] : _props3$foldList,
            toggleFoldItem = _props3.toggleFoldItem;

        var _ref3 = p || {},
            options = _ref3.options,
            extraButtons = _ref3.extraButtons;
        // prefer ui:options/buttons to ui:extraButtons, but keep both for backwards compatibility


        var buttons = options.buttons || extraButtons || [];
        var readonly = p.readonly,
            _p$schema = p.schema,
            schema = _p$schema === undefined ? {} : _p$schema;
        var maxItems = schema.maxItems;

        var list = p.value || [];
        if (!Array.isArray(list)) {
          console.error('"' + p.name + '"\u8FD9\u4E2A\u5B57\u6BB5\u76F8\u5173\u7684schema\u4E66\u5199\u9519\u8BEF\uFF0C\u8BF7\u68C0\u67E5\uFF01');
          return null;
        }
        var canAdd = maxItems ? maxItems > list.length : true; // 当到达最大个数，新增按钮消失
        return _react2.default.createElement(
          'ul',
          { className: 'pl0 ma0' },
          list.map(function (_, name) {
            return _react2.default.createElement(SortableItem, {
              key: 'item-' + name,
              index: name,
              name: name,
              p: p,
              fold: foldList[name],
              toggleFoldItem: toggleFoldItem,
              item: p.getSubField({
                name: name,
                value: p.value[name],
                onChange: function onChange(key, val) {
                  var value = [].concat(_toConsumableArray(p.value));
                  value[key] = val;
                  p.onChange(p.name, value);
                }
              })
            });
          }),
          !readonly && _react2.default.createElement(
            'div',
            { className: 'tr' },
            canAdd && _react2.default.createElement(
              ButtonComponent,
              { icon: 'add', onClick: this.handleAddClick },
              '\u65B0\u589E'
            ),
            buttons && buttons.length > 0 && buttons.map(function (item, i) {
              return _react2.default.createElement(
                ButtonComponent,
                {
                  className: 'ml2',
                  icon: item.icon,
                  key: i.toString(),
                  onClick: function onClick() {
                    if (item.callback === 'clearAll') {
                      p.onChange(p.name, []);
                      return;
                    }
                    if (item.callback === 'copyLast') {
                      var value = [].concat(_toConsumableArray(p.value));
                      var lastIndex = value.length - 1;
                      value.push(lastIndex > -1 ? value[lastIndex] : p.newItem);
                      p.onChange(p.name, value);
                      return;
                    }
                    if (typeof window[item.callback] === 'function') {
                      var _value = [].concat(_toConsumableArray(p.value));
                      var onChange = function onChange(value) {
                        return p.onChange(p.name, value);
                      };
                      window[item.callback](_value, onChange, p.newItem); // eslint-disable-line
                    }
                  }
                },
                item.text
              );
            })
          )
        );
      }
    }]);

    return _class4;
  }(_react2.default.Component);
};

function listHoc(ButtonComponent) {
  var _class5, _temp3;

  var SortableList = (0, _reactSortableHoc.SortableContainer)(fieldListHoc(ButtonComponent));
  return _temp3 = _class5 = function (_React$Component3) {
    _inherits(_class5, _React$Component3);

    function _class5(props) {
      _classCallCheck(this, _class5);

      var _this3 = _possibleConstructorReturn(this, (_class5.__proto__ || Object.getPrototypeOf(_class5)).call(this, props));

      _this3.addUnfoldItem = function () {
        return _this3.setState({
          foldList: [].concat(_toConsumableArray(_this3.state.foldList), [0])
        });
      };

      _this3.toggleFoldItem = function (index) {
        var _this3$state$foldList = _this3.state.foldList,
            foldList = _this3$state$foldList === undefined ? [] : _this3$state$foldList;

        foldList[index] = !foldList[index]; // TODO: need better solution for the weird behavior caused by setState being async
        _this3.setState({
          foldList: foldList
        });
      };

      _this3.handleSort = function (_ref4) {
        var oldIndex = _ref4.oldIndex,
            newIndex = _ref4.newIndex;
        var _this3$props = _this3.props,
            onChange = _this3$props.onChange,
            name = _this3$props.name,
            value = _this3$props.value;

        onChange(name, (0, _reactSortableHoc.arrayMove)(value, oldIndex, newIndex));
        _this3.setState({
          foldList: (0, _reactSortableHoc.arrayMove)(_this3.state.foldList, oldIndex, newIndex)
        });
      };

      var len = _this3.props.value.length || 0;
      _this3.state = {
        foldList: new Array(len).fill(false) || []
      };
      return _this3;
    }

    // 新添加的item默认是展开的


    _createClass(_class5, [{
      key: 'render',
      value: function render() {
        var foldList = this.state.foldList;

        return _react2.default.createElement(SortableList, {
          p: this.props,
          foldList: foldList,
          toggleFoldItem: this.toggleFoldItem,
          addUnfoldItem: this.addUnfoldItem,
          distance: 6,
          useDragHandle: true,
          helperClass: 'fr-sort-help-class',
          shouldCancelStart: function shouldCancelStart(e) {
            return e.toElement && e.toElement.className === 'fr-tooltip-container';
          },
          onSortEnd: this.handleSort
        });
      }
    }]);

    return _class5;
  }(_react2.default.Component), _class5.propTypes = {
    value: _propTypes2.default.array
  }, _class5.defaultProps = {
    value: []
  }, _temp3;
}