'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapping = exports.widgets = undefined;

var _checkbox = require('./checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _checkboxes = require('./checkboxes');

var _checkboxes2 = _interopRequireDefault(_checkboxes);

var _color = require('./color');

var _color2 = _interopRequireDefault(_color);

var _date = require('./date');

var _date2 = _interopRequireDefault(_date);

var _dateRange = require('./dateRange');

var _dateRange2 = _interopRequireDefault(_dateRange);

var _input = require('./input');

var _input2 = _interopRequireDefault(_input);

var _list = require('./list');

var _list2 = _interopRequireDefault(_list);

var _map = require('./map');

var _map2 = _interopRequireDefault(_map);

var _multiSelect = require('./multiSelect');

var _multiSelect2 = _interopRequireDefault(_multiSelect);

var _number = require('./number');

var _number2 = _interopRequireDefault(_number);

var _radio = require('./radio');

var _radio2 = _interopRequireDefault(_radio);

var _select = require('./select');

var _select2 = _interopRequireDefault(_select);

var _slider = require('./slider');

var _slider2 = _interopRequireDefault(_slider);

var _switch = require('./switch');

var _switch2 = _interopRequireDefault(_switch);

var _textarea = require('./textarea');

var _textarea2 = _interopRequireDefault(_textarea);

var _upload = require('./upload');

var _upload2 = _interopRequireDefault(_upload);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var widgets = exports.widgets = {
  checkbox: _checkbox2.default,
  checkboxes: _checkboxes2.default, // checkbox多选
  color: _color2.default,
  date: _date2.default,
  dateRange: _dateRange2.default,
  input: _input2.default,
  list: _list2.default,
  map: _map2.default,
  multiSelect: _multiSelect2.default, // 下拉多选
  number: _number2.default,
  radio: _radio2.default,
  select: _select2.default,
  slider: _slider2.default, // 带滚条的number
  switch: _switch2.default,
  textarea: _textarea2.default,
  upload: _upload2.default
};

var mapping = exports.mapping = {
  default: 'input',
  string: 'input',
  array: 'list',
  boolean: 'checkbox',
  integer: 'number',
  number: 'number',
  object: 'map',
  'string:upload': 'upload',
  'string:date': 'date',
  'string:dateTime': 'date',
  'string:time': 'date',
  'string:textarea': 'textarea',
  'string:color': 'color',
  'string:image': 'input',
  'range:date': 'dateRange',
  'range:dateTime': 'dateRange',
  '*?enum': 'select',
  'array?enum': 'checkboxes',
  '*?readonly': 'text'
};