'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _popover = require('antd/lib/popover');

var _popover2 = _interopRequireDefault(_popover);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = input;

require('antd/lib/input/style/css');

require('antd/lib/popover/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icons = require('@ant-design/icons');

var _previewContent = require('../../components/previewContent');

var _previewContent2 = _interopRequireDefault(_previewContent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var previewNode = function previewNode(format, value) {
  if (format !== 'image') {
    return null;
  }
  return _react2.default.createElement(
    _popover2.default,
    {
      content: (0, _previewContent2.default)(format, value),
      className: 'fr-preview',
      placement: 'bottom'
    },
    _react2.default.createElement(_icons.PictureOutlined, null)
  );
};

function input(p) {
  var _p$options = p.options,
      options = _p$options === undefined ? {} : _p$options,
      invalid = p.invalid;

  var style = invalid ? { borderColor: '#f5222d' } : {};
  var _p$schema$format = p.schema.format,
      format = _p$schema$format === undefined ? 'text' : _p$schema$format;

  var type = format === 'image' ? 'text' : format;
  var handleChange = function handleChange(e) {
    return p.onChange(p.name, e.target.value);
  };
  return _react2.default.createElement(_input2.default, _extends({
    style: style
  }, options, {
    value: p.value,
    type: type,
    disabled: p.disabled || p.readonly,
    addonAfter: options.addonAfter ? options.addonAfter : previewNode(format, p.value),
    onChange: handleChange
  }));
}