'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = checkboxes;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _next = require('@alifd/next');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function checkboxes(p) {
  var _ref = p.schema || {},
      enums = _ref.enum,
      enumNames = _ref.enumNames;

  var _value = p.value && Array.isArray(p.value) ? p.value : [];
  // if (p.readonly) {
  //   let displayText = _value.join(',');
  //   if (enumNames) {
  //     const idxs = _value.map(v => enums.indexOf(v));
  //     const nameList = enumNames.filter((e, i) => idxs.indexOf(i) > -1);
  //     displayText = nameList.join(',');
  //   }
  //   return <span>{displayText}</span>;
  // }
  return _react2.default.createElement(
    _next.Checkbox.Group,
    {
      disabled: p.disabled || p.readonly,
      value: _value,
      onChange: function onChange(values) {
        return p.onChange(p.name, values);
      }
    },
    (enums || [true, false]).map(function (val, index) {
      return _react2.default.createElement(
        _next.Checkbox,
        { value: val, key: index },
        _react2.default.createElement('span', {
          // eslint-disable-next-line react/no-danger
          dangerouslySetInnerHTML: {
            __html: enumNames ? enumNames[index] : val
          }
        })
      );
    })
  );
}