'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = color;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcColorPicker = require('rc-color-picker');

var _rcColorPicker2 = _interopRequireDefault(_rcColorPicker);

var _next = require('@alifd/next');

require('rc-color-picker/assets/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function color(p) {
  var format = p.schema.format;

  var onPickerChange = function onPickerChange(e) {
    if (p.disabled || p.readonly) return;
    p.onChange(p.name, e.color);
  };
  var onInputChange = function onInputChange(value) {
    // const isHex = value.match(/^(#{0,1})([0-9A-F]{6})$/i);
    p.onChange(p.name, value);
  };

  return _react2.default.createElement(
    'div',
    { className: 'fr-color-picker' },
    _react2.default.createElement(_rcColorPicker2.default, {
      type: format,
      animation: 'slide-up',
      color: p.value ? p.value : '#ffffff',
      onChange: onPickerChange
    }),
    p.readonly ? _react2.default.createElement(
      'span',
      null,
      p.value || '#ffffff'
    ) : _react2.default.createElement(_next.Input, {
      style: { width: '100%' },
      placeholder: '#ffffff',
      disabled: p.disabled,
      value: p.value,
      onChange: onInputChange
    })
  );
}