'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = date;

var _next = require('@alifd/next');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _dateHoc = require('../../components/dateHoc');

var _dateHoc2 = _interopRequireDefault(_dateHoc);

var _utils = require('../../base/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Updated by fateriddle on 2019-12-12.
 * 日期组件
 */

var MonthPicker = _next.DatePicker.MonthPicker,
    YearPicker = _next.DatePicker.YearPicker,
    WeekPicker = _next.DatePicker.WeekPicker;
function date(p) {
  var _p$schema$format = p.schema.format,
      format = _p$schema$format === undefined ? 'dateTime' : _p$schema$format;
  var picker = p.options.picker;

  var dateFormat = (0, _utils.getFormat)(format);
  var onChange = function onChange(value) {
    var timeValue = value ? (0, _moment2.default)(value).format(dateFormat) : '';
    p.onChange(p.name, timeValue);
  };

  var DateComponent = _next.DatePicker;
  if (format === 'time') {
    DateComponent = _next.TimePicker;
  } else {
    switch (picker) {
      case 'month':
        DateComponent = MonthPicker;
        break;
      case 'week':
        DateComponent = WeekPicker;
        break;
      case 'year':
        DateComponent = YearPicker;
        break;
      default:
        DateComponent = _next.DatePicker;
        break;
    }
  }

  return (0, _dateHoc2.default)(p, onChange, DateComponent);
}