'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = dateRange;

var _next = require('@alifd/next');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _rangeHoc = require('../../components/rangeHoc');

var _rangeHoc2 = _interopRequireDefault(_rangeHoc);

var _utils = require('../../base/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RangePicker = _next.DatePicker.RangePicker;
function dateRange(p) {
  var _p$schema$format = p.schema.format,
      format = _p$schema$format === undefined ? 'dateTime' : _p$schema$format;

  var dateFormat = (0, _utils.getFormat)(format);

  var onChange = function onChange(value) {
    if (Array.isArray(value)) {
      var result = value.map(
      // null 的时候返回空字符串
      function (item) {
        return (item || '') && (0, _moment2.default)(item).format(dateFormat);
      });
      p.onChange(p.name, result);
    }
  };
  return (0, _rangeHoc2.default)(p, onChange, RangePicker);
}