'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = input;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _next = require('@alifd/next');

var _previewContent = require('../../components/previewContent');

var _previewContent2 = _interopRequireDefault(_previewContent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var previewNode = function previewNode(format, value) {
  if (format !== 'image') {
    return null;
  }
  return _react2.default.createElement(
    _next.Balloon,
    {
      trigger: _react2.default.createElement(_next.Icon, { type: 'picture' }),
      className: 'fr-preview',
      align: 'tl'
    },
    (0, _previewContent2.default)(format, value)
  );
};
function input(p) {
  var _p$options = p.options,
      options = _p$options === undefined ? {} : _p$options,
      invalid = p.invalid;

  var style = invalid ? { borderColor: '#f5222d', width: '100%' } : { width: '100%' };

  var addonBefore = options.addonBefore,
      addonAfter = options.addonAfter,
      rest = _objectWithoutProperties(options, ['addonBefore', 'addonAfter']);

  var _p$schema$format = p.schema.format,
      format = _p$schema$format === undefined ? 'text' : _p$schema$format;

  var handleChange = function handleChange(value) {
    return p.onChange(p.name, value);
  };
  return _react2.default.createElement(_next.Input, _extends({
    style: style
  }, rest, {
    value: p.value,
    disabled: p.disabled || p.readonly,
    addonTextBefore: addonBefore ? addonBefore : '',
    addonTextAfter: addonAfter ? addonAfter : previewNode(format, p.value),
    onChange: handleChange
  }));
}