'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = input;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _next = require('@alifd/next');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function input(p) {
  var props = {
    name: 'file',
    listType: 'text',
    action: p.action,
    enctype: 'multipart/form-data',
    withCredentials: true,
    type: 'file',
    onChange: function onChange(res) {
      var info = res[0];
      if (info && info.response && info.response.status === 'done') {
        _next.Message.success(info.name + ' \u4E0A\u4F20\u6210\u529F');
        p.onChange(p.name, info.response.url);
      } else if (info && info.response && info.response.status === 'error') {
        _next.Message.error(info.file.name + ' \u4E0A\u4F20\u5931\u8D25');
      }
    },
    onRemove: function onRemove() {
      p.onChange(p.name, '');
    }
  };

  return _react2.default.createElement(
    'div',
    { className: 'fr-upload-mod' },
    _react2.default.createElement(
      _next.Upload,
      _extends({}, props, { className: 'fr-upload-file' }),
      _react2.default.createElement(
        _next.Button,
        null,
        _react2.default.createElement(_next.Icon, { type: 'upload' }),
        ' \u4E0A\u4F20'
      )
    ),
    p.value && _react2.default.createElement(
      'a',
      {
        href: p.value,
        target: '_blank',
        rel: 'noopener noreferrer',
        className: 'fr-upload-preview'
      },
      '\u5730\u5740\u67E5\u770B'
    )
  );
}